
//---------------------------------------------------------------------------
// BBMobile_Ardu_Retransmitter
//---------------------------------------------------------------------------
// This is sketch for BBMobile and Arduino.
// See more: www.bbmagic.net
//---------------------------------------------------------------------------
// To jest sketch dla Arduino i BBMobile.
// zobacz więcej: www.bbmagic.net
//---------------------------------------------------------------------------
#include <avr/pgmspace.h>
#include <SoftwareSerial.h>
#include "bbmobile_arduino_02.h"

// software serial port for communication with BBMobile module
#define BBM_SERIAL_RX     2
#define BBM_SERIAL_TX     3
SoftwareSerial bbmSerial(BBM_SERIAL_RX, BBM_SERIAL_TX); // RX, TX

// define Serial Monitor Port and BBMobile Serial Port
#define MON_SERIAL   Serial  
#define BBM_SERIAL   bbmSerial

//PINS for BBMobile powering
#define BBMOBILE_GND_PIN       4
#define BBMOBILE_POWER_PIN     5

unsigned int i ;

//--------------------------------------------------
// setup code here, to run once
//--------------------------------------------------
void setup()
{
  // initialize digital pin LED_BUILTIN as an output
  pinMode(LED_BUILTIN, OUTPUT);
  
  // for powering BBMobile from defined pins
  pinMode(BBMOBILE_GND_PIN, OUTPUT) ;
  digitalWrite(BBMOBILE_GND_PIN, LOW);    //-GND for BBMobile module
  pinMode(BBMOBILE_POWER_PIN, OUTPUT) ;
  digitalWrite(BBMOBILE_POWER_PIN, HIGH); //-VCC for BBMobile module
  
  // set the data rate for the Hardware Serial port
  MON_SERIAL.begin(9600) ;
  while(!MON_SERIAL) ;

  // set the data rate for the BBmagic Serial Port
  BBM_SERIAL.begin(9600) ;
  while(!BBM_SERIAL) ;
  // reserve the number of bytes in memory for BBMobile data
  //bbm_buf.reserve(100) ;  

  MON_SERIAL.println("\n\n** BBMobile Retransmitter START **") ;  

  MON_SERIAL.print("Searching for BBMobile") ;  
  do {
    MON_SERIAL.print(".") ;    
    digitalWrite(LED_BUILTIN, HIGH);   //-turn the LED on
    delay(500) ;    
    digitalWrite(LED_BUILTIN, LOW);    //-turn the LED off
    delay(500);         
  }while(BBMobileSendWaitAck(&BBM_SERIAL, "<hello")) ;
  MON_SERIAL.println("FOUND") ;

  MON_SERIAL.println("OK. GOTOWY.\nWpisz '<hello' i nacisnij ENTER") ;
}

//--------------------------------------------------
// main code here, to run repeatedly
//--------------------------------------------------
void loop()
{
  i++ ;
  
  // read from Monitor Port and send to BBMobile Port:
  if (MON_SERIAL.available()) {
    int inByte = MON_SERIAL.read();
    BBM_SERIAL.write(inByte);
  }

  // read from BBMobile Port and send to Monitor Port:
  if (BBM_SERIAL.available()) {
    int inByte = BBM_SERIAL.read();
    MON_SERIAL.write(inByte);
  }

  // LED blinking
  if(i ==4000) digitalWrite(LED_BUILTIN, LOW) ;  //-turn the LED off
  if(i > 20000)
  {
    i =0 ;
    digitalWrite(LED_BUILTIN, HIGH);  //-turn the LED on  
  }
}
